// scale (optimized for 720p->1080p)


uniform sampler2D source;
//uniform sampler1D sincLut;

const float pi = 3.14159265;

const float scaleFactor = 1.5;
const float N = 2.5;

const float xPitch = 1.0/1280.0;
const float yPitch = 1.0/720.0;

//float sinc(float x) {
//  return texture1D(sincLut, x*0.2);
//}
  
float sinc(float x) {
  return sin(x)/(x);
}
float lanczos(float dist, float N) {
  return sinc(dist) * sinc(dist/N);
}

void main(void)
{
  vec2 tc = vec2(gl_TexCoord[0]);
  vec4 result = vec4(0.0);
  float fsum = 0.0;
  
  for(float x=-2.0; x<2.1; x++) {
    for(float y=-2.0; y<2.1; y++) {
      vec2 dist = vec2(x, y)/scaleFactor;
      float ll = length(dist)*pi;
      float weight = lanczos(ll, N);
      if(abs(ll)<0.1) weight = 1.0;
      fsum += weight;
      result += weight*texture2D(source, tc + dist*vec2(xPitch,yPitch));
    }
  }

  //gl_FragColor = vec4(vec3(lanczos(length((tc-0.5)*2.0), N))/2.0+0.5,1.0);
  gl_FragColor = result/fsum;
}
